// ************************************************************* 
// Programmbeispiel: 	Einlesen der Potentiometer R3,R4 ber ADC Kanal 9 und 10
//						Aufloesung 10bit								                           
// Datum: 25.10.2005: mpa										 
//  
                                   

                                   

#include<reg517a.h>
#include<stdio.h>
#include<lcd.h>


// Globale variablen (beginnen mit g...)
char gTXT[25];								// Allgemeiner Textbuffer


// Deklaration der Funktionen
int aduwert(char);							// ADU lesen

main()
{

float u1,u2;								// Spannungswerte gemessen
int	  adu1,adu2;							// Ergebnisse der AD-Umsetzer

init_lcd();									// LCD initialisieren
blank_lcd();								// LCD loeschen


while(1)										// Endlosschleife
	{
	adu1 = aduwert(10);							// ADU  Kanal 10 lesen 
	adu2 = aduwert( 9);							// ADU  Kanal  9 lesen 	
										
	sprintf(gTXT,"ad1=%4d  ad2=%4d ",adu1,adu2);// Messwerte ausgeben
	print_lcd(1,1,gTXT);						// String auf LCD ausgeben. Zeile 1

	u1 = 5.0*adu1/1024;							// Spannung berechnen 1 LSB = 5V/1024 
	u2 = 5.0*adu2/1024;							// Spannung berechnen 1 LSB = 5V/1024 
	sprintf(gTXT,"U1=%5.3fV U2=%5.3fV",u1,u2);	// Messwerte ausgeben
	print_lcd(2,1,gTXT);						// String auf LCD ausgeben. Zeile 2
	}
}


// Starten einer Analog-Digital-Umsetzung 
// Parameter:	char...Eingabekanal (0-11)
// Rueckgabe:	ADU-Wert int

int aduwert(char kanal)
{
int result;
unsigned int low,high;				// unsigned, damit nicht arithmetisch geschobe wird
ADCON1=kanal;						// ADC Kanal festlegen 0-11
ADDATL = 0;							// Schreibzugriff auf ADDTAL startet Umsetzung
while(BSY)	{;}						// Warte bis BSY Flag Null wird ( Bit 5  in ADCON0 )
low  = ADDATL >> 6;					// ADDATL.7,ADDATL.6 (D1,D0) an Position 1 und 0 schieben
high = ADDATH << 2;					// ADDATH.7 bis ADDATH.0 (D9-D2) an Position 9 bis 2 schieben
result = (int)(high+low);			// Ergebnis zusammensetzen
return(result);
}

